import type { Router__ } from '../router';
export declare class RouteEntry {
    readonly router: Router__;
    readonly path: string[];
    readonly stateMap: Map<number, object>;
    readonly previous: RouteTarget | undefined;
    private enteringSet;
    private leavingSet;
    private states;
    private pendingStatePart;
    readonly mergedState: object;
    constructor(router: Router__, path: string[], stateMap: Map<number, object>, previous: RouteTarget | undefined, pendingStatePart: object | undefined);
    get target(): RouteTarget;
    get blockedByEntering(): boolean;
    get blockedByLeaving(): boolean;
    get active(): boolean;
    get transition(): boolean;
    get switching(): boolean;
    get leaving(): boolean;
    updateTransitionBlock(ref: object, { entering, leaving }: RouteEntryRegisterTransitionOptions): void;
    mergePendingStatePart(): void;
}
export interface RouteTarget {
    path: string[];
    stateMap: Map<number, object>;
    previous: RouteTarget | undefined;
    statePart: object | undefined;
}
