import type { RouterOperation, RouterSetResult, Router__ } from '../router';
import type { RouteTarget } from './route-entry';
import type { RouteSwitching } from './route-switching';
export interface RouteOperationTarget {
    path: string[];
    stateMap: Map<number, object>;
    previous: RouteTarget | undefined;
}
export declare function createRouteOperation(router: Router__, operation: RouterOperation, targetBuilder: () => RouteOperationTarget): RouteOperation<object, object>;
export type RouteOperation<TMergedState extends object, TSwitchingState extends object> = RouteOperationClass<TMergedState, TSwitchingState> & {
    bivariance(statePart?: Partial<TMergedState>): RouterSetResult;
}['bivariance'];
export type RouteOperation__ = RouteOperation<object, object>;
export declare class RouteOperationClass<TMergedState extends object, TSwitchingState extends object> {
    private router;
    private operation;
    private targetBuilder;
    constructor(router: Router__, operation: RouterOperation, targetBuilder: () => RouteOperationTarget);
    $switch(statePart?: Partial<TMergedState>, switchingState?: TSwitchingState): RouteSwitching<TSwitchingState>;
}
