"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RouteOperationClass = exports.createRouteOperation = void 0;
function createRouteOperation(router, operation, targetBuilder) {
    // E.g.: router.home.$push();
    return Object.setPrototypeOf((statePart = {}) => router._set(operation, () => {
        return {
            ...targetBuilder(),
            statePart,
        };
    }), new RouteOperationClass(router, operation, targetBuilder));
}
exports.createRouteOperation = createRouteOperation;
class RouteOperationClass {
    constructor(router, operation, targetBuilder) {
        Object.defineProperty(this, "router", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: router
        });
        Object.defineProperty(this, "operation", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: operation
        });
        Object.defineProperty(this, "targetBuilder", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: targetBuilder
        });
    }
    $switch(statePart = {}, switchingState) {
        return this.router._switch(this.operation, {
            ...this.targetBuilder(),
            statePart,
        }, switchingState);
    }
}
exports.RouteOperationClass = RouteOperationClass;
//# sourceMappingURL=route-operation.js.map