"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RouteSwitchingObject = exports.createRouteSwitching = void 0;
const mobx_1 = require("mobx");
function createRouteSwitching(router, switchingStateObservable, ref) {
    return Object.setPrototypeOf((switchingState) => {
        (0, mobx_1.runInAction)(() => {
            switchingStateObservable.set(switchingState);
        });
    }, new RouteSwitchingObject(router, ref));
}
exports.createRouteSwitching = createRouteSwitching;
class RouteSwitchingObject {
    constructor(router, ref) {
        Object.defineProperty(this, "router", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: router
        });
        Object.defineProperty(this, "ref", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: ref
        });
    }
    $complete() {
        this.router._completeSwitching(this.ref);
    }
    $abort() {
        this.router._abortSwitching(this.ref);
    }
}
exports.RouteSwitchingObject = RouteSwitchingObject;
//# sourceMappingURL=route-switching.js.map