import type { ChildSchemaFallback_, SchemaStateInput_, SchemaState_ } from '../@schema';
import type { OverrideObject_ } from '../@utils';
import type { Router__ } from '../router';
import type { CreateViewOptions } from '../routra';
import type { RouteKey, Schema } from '../schema';
import type { IView } from '../view';
import type { RouteOperation } from './route-operation';
export type Route__ = Route_<unknown, object, object, string[]>;
export type RouteClass__ = RouteClass<unknown, object, object, string[]>;
export type RouteNode__ = RouteNode_<unknown, object, object, string[]>;
export type RouteNodeClass__ = RouteNodeClass<unknown, object, object, string[]>;
export declare function createRoute(router: Router__, schema: Schema, path: string[], stateMapUpdate: Map<number, object>): Route__ | RouteNode__;
export declare class RouteNodeClass<TSchema, TSwitchingState extends object, TMergedState extends object, TPath extends string[]> {
    readonly $router: Router__;
    readonly $path: TPath;
    protected _stateMapUpdate: Map<number, object>;
    [__static_type]: [TSchema, TSwitchingState, TMergedState, TPath];
    readonly $key: string;
    private _exact;
    private _exactClone;
    constructor($router: Router__, schema: Schema, $path: TPath, _stateMapUpdate: Map<number, object>);
    get $exact(): this;
    get $matched(): boolean;
    get $active(): boolean;
    get $transition(): boolean;
    get $switching(): boolean;
    $view(options?: CreateViewOptions): IView<this>;
    private _isMatched;
}
interface RouteNodeStateSetterBivariance<TSchema, TSwitchingState extends object, TMergedState extends object, TPath extends string[]> {
    bivariance(state: SchemaStateInput_<TSchema>): RouteNodeClass<TSchema, TSwitchingState, TMergedState, TPath> & RouteRoutes_<TSchema, TSwitchingState, TMergedState, TPath>;
}
type RouteNodeStateSetter<TSchema, TSwitchingState extends object, TMergedState extends object, TPath extends string[]> = RouteNodeStateSetterBivariance<TSchema, TSwitchingState, TMergedState, TPath>['bivariance'];
export type RouteNode_<TSchema, TSwitchingState extends object, TMergedState extends object, TPath extends string[]> = RouteNodeClass<TSchema, TSwitchingState, TMergedState, TPath> & RouteNodeStateSetter<TSchema, TSwitchingState, TMergedState, TPath>;
export declare class RouteClass<TSchema, TSwitchingState extends object, TMergedState extends object, TPath extends string[]> extends RouteNodeClass<TSchema, TSwitchingState, TMergedState, TPath> {
    constructor($router: Router__, schema: Schema, $path: TPath, stateMapUpdate: Map<number, object>);
    get $reset(): RouteOperation<TMergedState, TSwitchingState>;
    get $push(): RouteOperation<TMergedState, TSwitchingState>;
    get $replace(): RouteOperation<TMergedState, TSwitchingState>;
}
declare const __static_type: unique symbol;
interface RouteStateSetterBivariance<TSchema, TSwitchingState extends object, TMergedState extends object, TPath extends string[]> {
    bivariance(state: SchemaStateInput_<TSchema>): RouteClass<TSchema, TSwitchingState, TMergedState, TPath> & RouteRoutes_<TSchema, TSwitchingState, TMergedState, TPath>;
}
type RouteStateSetter<TSchema, TSwitchingState extends object, TMergedState extends object, TPath extends string[]> = RouteStateSetterBivariance<TSchema, TSwitchingState, TMergedState, TPath>['bivariance'];
export type Route_<TSchema, TSwitchingState extends object, TMergedState extends object, TPath extends string[]> = RouteClass<TSchema, TSwitchingState, TMergedState, TPath> & RouteStateSetter<TSchema, TSwitchingState, TMergedState, TPath>;
export type RouteRoutes_<TSchema, TSwitchingState extends object, TMergedState extends object, TPath extends string[]> = {
    [TKey in Extract<keyof TSchema, RouteKey>]: RouteType_<ChildSchemaFallback_<TSchema[TKey]>, TSwitchingState, TMergedState, [
        ...TPath,
        TKey
    ]>;
};
export type RouteType_<TSchema, TSwitchingState extends object, TUpperMergedState extends object, TPath extends string[]> = OverrideObject_<TUpperMergedState, SchemaState_<TSchema>> extends infer TMergedState extends object ? (TSchema extends {
    $exact: false;
} ? RouteNode_<TSchema, TSwitchingState, TMergedState, TPath> : Route_<TSchema, TSwitchingState, TMergedState, TPath>) & RouteRoutes_<TSchema, TSwitchingState, TMergedState, TPath> : never;
export type Route<TSchema extends Schema, TSwitchingState extends object, TUpperMergedState extends object, TPath extends string[]> = RouteType_<TSchema, TSwitchingState, TUpperMergedState, TPath>;
export type RouteSwitchingState_<TRoute> = TRoute extends RouteNodeClass<any, infer TSwitchingState, any, any> ? TSwitchingState : {};
export type RouteMergedState_<TRoute> = TRoute extends RouteNodeClass<any, any, infer TMergedState, any> ? TMergedState : {};
export {};
