"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.routra = void 0;
const tslib_1 = require("tslib");
const multikey_map_1 = tslib_1.__importDefault(require("multikey-map"));
const router_1 = require("./router");
const view_1 = require("./view");
function routra(schemas, options = { defaultSwitchingState: undefined }) {
    return new router_1.RouterClass(schemas, options);
}
exports.routra = routra;
(function (routra) {
    const viewCache = new multikey_map_1.default();
    function $view(routes, { single = false } = {}) {
        const key = [single, ...routes];
        let view = viewCache.get(key);
        if (!view) {
            view = single ? new view_1.SingleView__(routes) : new view_1.ParallelView__(routes);
            viewCache.set(key, view);
        }
        return view;
    }
    routra.$view = $view;
})(routra = exports.routra || (exports.routra = {}));
//# sourceMappingURL=routra.js.map