import type { RouteMergedState_, RouteNodeClass__, RouteSwitchingState_ } from '../route';
import type { RouterOperation } from '../router';
declare abstract class ViewEntryClass<TRoute extends RouteNodeClass__> {
    readonly $key: number;
    protected _enteringEnabled: boolean;
    protected _leavingEnabled: boolean;
    protected _entered: boolean;
    protected _left: boolean;
    private _autorunDisposer;
    private enteringTransitionActivity;
    private leavingTransitionActivity;
    constructor();
    get $entering(): ViewTransitionActivity | undefined;
    get $leaving(): ViewTransitionActivity | undefined;
    get $switching(): ViewSwitchingActivity<TRoute> | undefined;
    get $match(): TRoute;
    abstract get $operation(): RouterOperation;
    protected abstract get _entering(): boolean;
    protected abstract get _leaving(): boolean;
    $transition: ({ entering, leaving, }: ViewEntryRegisterTransitionOptions) => void;
    protected abstract _autorunUpdateTransitionBlock(): void;
}
export declare const AbstractViewEntry: typeof ViewEntryClass;
export type IViewEntry<TRoute extends RouteNodeClass__> = ViewEntryClass<TRoute>;
export type ViewEntry<TRoute extends RouteNodeClass__> = ViewEntryClass<TRoute> & RouteMergedState_<TRoute>;
export type ViewEntry__ = ViewEntry<RouteNodeClass__>;
export interface ViewEntryRegisterTransitionOptions {
    entering?: boolean;
    leaving?: boolean;
}
export interface ViewTransitionActivity {
    $operation: RouterOperation;
    $complete(): boolean;
}
export type ViewSwitchingRelationship = 'from' | 'to';
export type ViewSwitchingActivity<TRoute extends RouteNodeClass__> = RouteSwitchingState_<TRoute> & {
    $operation: RouterOperation;
    $rel: ViewSwitchingRelationship;
};
export {};
