import { runInAction } from 'mobx';
export function createRouteSwitching(router, switchingStateObservable, ref) {
    return Object.setPrototypeOf((switchingState) => {
        runInAction(() => {
            switchingStateObservable.set(switchingState);
        });
    }, new RouteSwitchingObject(router, ref));
}
export class RouteSwitchingObject {
    constructor(router, ref) {
        Object.defineProperty(this, "router", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: router
        });
        Object.defineProperty(this, "ref", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: ref
        });
    }
    $complete() {
        this.router._completeSwitching(this.ref);
    }
    $abort() {
        this.router._abortSwitching(this.ref);
    }
}
//# sourceMappingURL=route-switching.js.map