import MultikeyMap from 'multikey-map';
import { RouterClass } from './router';
import { ParallelView__, SingleView__ } from './view';
export function routra(schemas, options = { defaultSwitchingState: undefined }) {
    return new RouterClass(schemas, options);
}
(function (routra) {
    const viewCache = new MultikeyMap();
    function $view(routes, { single = false } = {}) {
        const key = [single, ...routes];
        let view = viewCache.get(key);
        if (!view) {
            view = single ? new SingleView__(routes) : new ParallelView__(routes);
            viewCache.set(key, view);
        }
        return view;
    }
    routra.$view = $view;
})(routra || (routra = {}));
//# sourceMappingURL=routra.js.map