import { __decorate } from "tslib";
import { computed, runInAction } from 'mobx';
import { AbstractView } from './view';
import { AbstractViewEntry } from './view-entry';
export class ParallelView__ extends AbstractView {
    constructor() {
        super(...arguments);
        Object.defineProperty(this, "_routeEntryToViewEntryMap", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Map()
        });
    }
    get _entries() {
        const matches = this._matches;
        const routeEntryToViewEntryMap = this._routeEntryToViewEntryMap;
        const pendingIteratingRouteEntries = new Set(routeEntryToViewEntryMap.keys());
        for (const match of matches) {
            const { entry } = match;
            pendingIteratingRouteEntries.delete(entry);
            if (routeEntryToViewEntryMap.has(entry)) {
                continue;
            }
            routeEntryToViewEntryMap.set(entry, new ParallelViewEntry__(match));
        }
        for (const routeEntry of pendingIteratingRouteEntries) {
            const viewEntry = routeEntryToViewEntryMap.get(routeEntry);
            viewEntry._dispose();
            routeEntryToViewEntryMap.delete(routeEntry);
        }
        return Array.from(routeEntryToViewEntryMap.values());
    }
}
__decorate([
    computed
], ParallelView__.prototype, "_entries", null);
export class ParallelViewEntry__ extends AbstractViewEntry {
    constructor(match) {
        super();
        /** @internal */
        Object.defineProperty(this, "_match", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "$operation", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this._match = match;
        this.$operation = match.operation;
    }
    get _entering() {
        return this._match.entry.transition;
    }
    get _leaving() {
        return this._match.entry.leaving;
    }
    /** @internal */
    _dispose() {
        super._dispose();
        runInAction(() => {
            this._match.entry.updateTransitionBlock(this, {
                entering: false,
                leaving: false,
            });
        });
    }
    _autorunUpdateTransitionBlock() {
        const enteringEnabled = this._enteringEnabled;
        const leavingEnabled = this._leavingEnabled;
        const entered = this._entered;
        const left = this._left;
        runInAction(() => {
            this._match.entry.updateTransitionBlock(this, {
                entering: enteringEnabled && !entered,
                leaving: leavingEnabled && !left,
            });
        });
    }
}
//# sourceMappingURL=parallel-view.js.map