import { __decorate } from "tslib";
import { computed, runInAction } from 'mobx';
import { AbstractView } from './view';
import { AbstractViewEntry } from './view-entry';
export class SingleView__ extends AbstractView {
    constructor() {
        super(...arguments);
        Object.defineProperty(this, "_entry", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
    }
    get _entries() {
        let entry = this._entry;
        if (this._matches.length === 0) {
            if (entry) {
                entry._dispose();
                entry = undefined;
                this._entry = undefined;
            }
        }
        else {
            if (!entry) {
                entry = new SingleViewEntry__(this);
                this._entry = entry;
            }
        }
        return entry ? [entry] : [];
    }
}
__decorate([
    computed
], SingleView__.prototype, "_entries", null);
export class SingleViewEntry__ extends AbstractViewEntry {
    constructor(_view) {
        super();
        Object.defineProperty(this, "_view", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: _view
        });
        Object.defineProperty(this, "$operation", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "_blockedActive", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "_blockedTransition", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.$operation = this._match.operation;
    }
    /** @internal */
    get _match() {
        var _a, _b;
        return ((_b = (_a = this._active) !== null && _a !== void 0 ? _a : this._transition) !== null && _b !== void 0 ? _b : this._switching);
    }
    get _entering() {
        const active = this._active;
        const transition = this._transition;
        return active === undefined && transition !== undefined;
    }
    get _leaving() {
        const active = this._active;
        return active !== undefined && active.entry.leaving;
    }
    get _active() {
        return this._view._matches.find(match => match.entry.active);
    }
    get _transition() {
        return this._view._matches.find(match => match.entry.transition);
    }
    get _switching() {
        return this._view._matches.find(match => match.entry.switching);
    }
    /** @internal */
    _dispose() {
        super._dispose();
        runInAction(() => {
            if (this._blockedActive) {
                this._blockedActive.updateTransitionBlock(this, {
                    entering: false,
                    leaving: false,
                });
                this._blockedActive = undefined;
            }
            if (this._blockedTransition) {
                this._blockedTransition.updateTransitionBlock(this, {
                    entering: false,
                    leaving: false,
                });
                this._blockedTransition = undefined;
            }
        });
    }
    _autorunUpdateTransitionBlock() {
        var _a, _b;
        const blockedActive = this._blockedActive;
        const blockedTransition = this._blockedTransition;
        const active = (_a = this._active) === null || _a === void 0 ? void 0 : _a.entry;
        const transition = (_b = this._transition) === null || _b === void 0 ? void 0 : _b.entry;
        const enteringEnabled = this._enteringEnabled;
        const leavingEnabled = this._leavingEnabled;
        const entered = this._entered;
        const left = this._left;
        runInAction(() => {
            if (blockedActive && blockedActive !== active) {
                blockedActive.updateTransitionBlock(this, {
                    entering: false,
                    leaving: false,
                });
            }
            if (blockedTransition &&
                blockedTransition !== transition &&
                blockedTransition !== active) {
                blockedTransition.updateTransitionBlock(this, {
                    entering: false,
                    leaving: false,
                });
            }
            this._blockedActive = undefined;
            this._blockedTransition = undefined;
            if (active && transition) {
                // Transition going on, but treated as stable for single view.
                active.updateTransitionBlock(this, {
                    entering: false,
                    leaving: false,
                });
                transition.updateTransitionBlock(this, {
                    entering: false,
                    leaving: false,
                });
            }
            else if (active) {
                // Stable or leaving.
                // Make sure to not block route if already left.
                const blocked = leavingEnabled && !left;
                if (blocked) {
                    this._blockedActive = active;
                }
                active.updateTransitionBlock(this, {
                    entering: false,
                    leaving: blocked,
                });
            }
            else if (transition) {
                // Entering.
                // Make sure to not block route if already entered.
                const blocked = enteringEnabled && !entered;
                if (blocked) {
                    this._blockedTransition = transition;
                }
                transition.updateTransitionBlock(this, {
                    entering: blocked,
                    leaving: false,
                });
            }
        });
    }
}
__decorate([
    computed
], SingleViewEntry__.prototype, "_match", null);
__decorate([
    computed
], SingleViewEntry__.prototype, "_active", null);
__decorate([
    computed
], SingleViewEntry__.prototype, "_transition", null);
__decorate([
    computed
], SingleViewEntry__.prototype, "_switching", null);
//# sourceMappingURL=single-view.js.map